aboutsummaryrefslogtreecommitdiffstats
path: root/package/firewall/files/lib/core_interface.sh
diff options
context:
space:
mode:
authorJo-Philipp Wich <jow@openwrt.org>2010-05-19 00:50:14 +0000
committerJo-Philipp Wich <jow@openwrt.org>2010-05-19 00:50:14 +0000
commit36a417a05f6020ea814c3c04ee880eb32ff06ab5 (patch)
tree1a4037a5def167640cc2674f082661faae384121 /package/firewall/files/lib/core_interface.sh
parentdd8ec17c9dbdf53026c77661d87592671efddf56 (diff)
downloadupstream-36a417a05f6020ea814c3c04ee880eb32ff06ab5.tar.gz
upstream-36a417a05f6020ea814c3c04ee880eb32ff06ab5.tar.bz2
upstream-36a417a05f6020ea814c3c04ee880eb32ff06ab5.zip
[package] firewall (#7355)
- partially revert r21486, start firewall on init again - skip iface hotplug events if base fw is not up yet - get ifname and up state with uci_get_state() in iface setup since the values gathered by scan_interfaces() may be outdated when iface coldplugging happens (observed with pptp) - ignore up state when bringing down interfaces because ifdown reverts state vars before dispatching the iface event - bump package revision git-svn-id: svn://svn.openwrt.org/openwrt/trunk@21502 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/firewall/files/lib/core_interface.sh')
-rw-r--r--package/firewall/files/lib/core_interface.sh12
1 files changed, 5 insertions, 7 deletions
diff --git a/package/firewall/files/lib/core_interface.sh b/package/firewall/files/lib/core_interface.sh
index 9da6739f0e..9b35c8b2bc 100644
--- a/package/firewall/files/lib/core_interface.sh
+++ b/package/firewall/files/lib/core_interface.sh
@@ -5,14 +5,12 @@ fw_configure_interface() {
local action=$2
local ifname=$3
- local status;
- config_get_bool status "$iface" up "0"
- [ "$status" == 1 ] || return 0
-
- [ -n "$ifname" ] || {
- config_get ifname "$iface" ifname
- ifname=${ifname:-$iface}
+ [ "$action" == "add" ] && {
+ local status=$(uci_get_state network "$iface" up 0)
+ [ "$status" == 1 ] || return 0
}
+
+ [ -n "$ifname" ] || ifname=$(uci_get_state network "$iface" ifname "$iface")
[ "$ifname" == "lo" ] && return 0
fw_callback pre interface